Data Connections - Create Or Update

Creates or updates a data connection.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Kusto/clusters/{clusterName}/databases/{databaseName}/dataConnections/{dataConnectionName}?api-version=2025-02-14

URI Parameters

Name In Required Type Description
clusterName
path True

string

pattern: ^.*$

The name of the Kusto cluster.

databaseName
path True

string

pattern: ^.*$

The name of the database in the Kusto cluster.

dataConnectionName
path True

string

pattern: ^.*$

The name of the data connection.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string

minLength: 1

The ID of the target subscription.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

The request body can be one of the following:

Name Description
CosmosDbDataConnection

Class representing a CosmosDb data connection.

EventGridDataConnection

Class representing an Event Grid data connection.

EventGridDataConnectionWithManagedIdentity

Class representing an Event Grid data connection with mandatory managed identity.

EventHubDataConnection

Class representing an event hub data connection.

EventHubDataConnectionWithManagedIdentity

Class representing an event hub data connection with required managed identity.

IotHubDataConnection

Class representing an iot hub data connection.

CosmosDbDataConnection

Class representing a CosmosDb data connection.

Name Required Type Description
kind True string:

CosmosDb

Kind of the endpoint for the data connection

properties.cosmosDbAccountResourceId True

string

The resource ID of the Cosmos DB account used to create the data connection.

properties.cosmosDbContainer True

string

The name of an existing container in the Cosmos DB database.

properties.cosmosDbDatabase True

string

The name of an existing database in the Cosmos DB account.

properties.managedIdentityResourceId True

string

The resource ID of a managed system or user-assigned identity. The identity is used to authenticate with Cosmos DB.

properties.tableName True

string

The case-sensitive name of the existing target table in your cluster. Retrieved data is ingested into this table.

location

string

Resource location.

properties.mappingRuleName

string

The name of an existing mapping rule to use when ingesting the retrieved data.

properties.retrievalStartDate

string (date-time)

Optional. If defined, the data connection retrieves Cosmos DB documents created or updated after the specified retrieval start date.

EventGridDataConnection

Class representing an Event Grid data connection.

Name Required Type Description
kind True string:

EventGrid

Kind of the endpoint for the data connection

properties.consumerGroup True

string

The event hub consumer group.

properties.eventHubResourceId True

string

The resource ID where the event grid is configured to send events.

properties.storageAccountResourceId True

string

The resource ID of the storage account where the data resides.

location

string

Resource location.

properties.blobStorageEventType

BlobStorageEventType

The name of blob storage event type to process.

properties.dataFormat

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventGridResourceId

string

The resource ID of the event grid that is subscribed to the storage account events.

properties.ignoreFirstRecord

boolean

A Boolean value that, if set to true, indicates that ingestion should ignore the first record of every file

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub and storage account.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

EventGridDataConnectionWithManagedIdentity

Class representing an Event Grid data connection with mandatory managed identity.

Name Required Type Description
kind True string:

EventGridWithManagedIdentity

Kind of the endpoint for the data connection

properties.consumerGroup True

string

The event hub consumer group.

properties.eventHubResourceIdForManagedIdentity True

string

The resource ID of the event hub that is subscribed to the storage account events.

properties.managedIdentityResourceId True

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub and storage account.

properties.storageAccountResourceIdForManagedIdentity True

string

The resource ID of the storage account where the data resides.

location

string

Resource location.

properties.blobStorageEventType

BlobStorageEventType

The name of blob storage event type to process.

properties.dataFormat

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventGridResourceId

string

The resource ID where the event grid is configured to send events.

properties.ignoreFirstRecord

boolean

A Boolean value that, if set to true, indicates that ingestion should ignore the first record of every file

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

EventHubDataConnection

Class representing an event hub data connection.

Name Required Type Description
kind True string:

EventHub

Kind of the endpoint for the data connection

properties.consumerGroup True

string

The event hub consumer group.

properties.eventHubResourceId True

string

The resource ID of the event hub to be used to create a data connection.

location

string

Resource location.

properties.compression

Compression

The compression type

properties.dataFormat

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventSystemProperties

string[]

System properties of the event hub

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

EventHubDataConnectionWithManagedIdentity

Class representing an event hub data connection with required managed identity.

Name Required Type Description
kind True string:

EventHubWithManagedIdentity

Kind of the endpoint for the data connection

properties.consumerGroup True

string

The event hub consumer group.

properties.eventHubResourceIdForManagedIdentity True

string

The resource ID of the event hub to be used to create a data connection.

properties.managedIdentityResourceId True

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub.

location

string

Resource location.

properties.compression

Compression

The compression type

properties.dataFormat

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventSystemProperties

string[]

System properties of the event hub

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

IotHubDataConnection

Class representing an iot hub data connection.

Name Required Type Description
kind True string:

IotHub

Kind of the endpoint for the data connection

properties.consumerGroup True

string

The iot hub consumer group.

properties.iotHubResourceId True

string

The resource ID of the Iot hub to be used to create a data connection.

properties.sharedAccessPolicyName True

string

The name of the share access policy

location

string

Resource location.

properties.dataFormat

IotHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventSystemProperties

string[]

System properties of the iot hub

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

Responses

Name Type Description
200 OK DataConnection:

Resource 'DataConnection' update operation succeeded

201 Created DataConnection:

The request has succeeded and a new resource has been created as a result.

202 Accepted DataConnection:

The request has been accepted for processing, but processing has not yet completed.

Headers

  • Azure-AsyncOperation: string
  • Location: string
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

KustoDataConnectionsCosmosDbCreateOrUpdate
KustoDataConnectionsCreateOrUpdate
KustoDataConnectionsEventGridCreateOrUpdate
KustoDataConnectionsEventGridWithManagedIdentityCreateOrUpdate
KustoDataConnectionsEventHubWithManagedIdentityCreateOrUpdate

KustoDataConnectionsCosmosDbCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster/databases/KustoDatabase1/dataConnections/dataConnectionTest?api-version=2025-02-14

{
  "kind": "CosmosDb",
  "location": "westus",
  "properties": {
    "cosmosDbAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.DocumentDb/databaseAccounts/cosmosDbAccountTest1",
    "cosmosDbContainer": "cosmosDbContainerTest",
    "cosmosDbDatabase": "cosmosDbDatabaseTest",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "retrievalStartDate": "2022-07-29T12:00:00.6554616Z",
    "tableName": "TestTable"
  }
}

Sample response

Azure-AsyncOperation: https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/providers/Microsoft.Kusto/locations/westus/operationResults/742bef43-608b-4b58-ba96-6f7a32ec5f0f?api-version=2022-12-29
{
  "name": "kustoCluster/KustoDatabase1/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase1/DataConnections/dataConnectionTest",
  "kind": "CosmosDb",
  "location": "westus",
  "properties": {
    "cosmosDbAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.DocumentDb/databaseAccounts/cosmosDbAccountTest1",
    "cosmosDbContainer": "cosmosDbContainerTest",
    "cosmosDbDatabase": "cosmosDbDatabaseTest",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "retrievalStartDate": "2022-07-29T12:00:00.6554616Z",
    "tableName": "TestTable"
  }
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/providers/Microsoft.Kusto/locations/westus/operationResults/742bef43-608b-4b58-ba96-6f7a32ec5f0f?api-version=2022-12-29
{
  "name": "kustoCluster/KustoDatabase1/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase1/DataConnections/dataConnectionTest",
  "kind": "CosmosDb",
  "location": "westus",
  "properties": {
    "cosmosDbAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.DocumentDb/databaseAccounts/cosmosDbAccountTest1",
    "cosmosDbContainer": "cosmosDbContainerTest",
    "cosmosDbDatabase": "cosmosDbDatabaseTest",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "retrievalStartDate": "2022-07-29T12:00:00.6554616Z",
    "tableName": "TestTable"
  }
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/providers/Microsoft.Kusto/locations/westus/operationResults/742bef43-608b-4b58-ba96-6f7a32ec5f0f?api-version=2022-12-29
{
  "name": "kustoCluster/KustoDatabase1/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase1/DataConnections/dataConnectionTest",
  "kind": "CosmosDb",
  "location": "westus",
  "properties": {
    "cosmosDbAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.DocumentDb/databaseAccounts/cosmosDbAccountTest1",
    "cosmosDbContainer": "cosmosDbContainerTest",
    "cosmosDbDatabase": "cosmosDbDatabaseTest",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "retrievalStartDate": "2022-07-29T12:00:00.6554616Z",
    "tableName": "TestTable"
  }
}

KustoDataConnectionsCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster/databases/KustoDatabase8/dataConnections/dataConnectionTest?api-version=2025-02-14

{
  "kind": "EventHub",
  "location": "westus",
  "properties": {
    "consumerGroup": "testConsumerGroup1",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1"
  }
}

Sample response

{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "kind": "EventHub",
  "location": "westus",
  "properties": {
    "compression": "None",
    "consumerGroup": "testConsumerGroup1",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1"
  }
}
{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "kind": "EventHub",
  "location": "westus",
  "properties": {
    "compression": "None",
    "consumerGroup": "testConsumerGroup1",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1"
  }
}
{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "kind": "EventHub",
  "location": "westus",
  "properties": {
    "compression": "None",
    "consumerGroup": "testConsumerGroup1",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1"
  }
}

KustoDataConnectionsEventGridCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster/databases/KustoDatabase8/dataConnections/dataConnectionTest?api-version=2025-02-14

{
  "kind": "EventGrid",
  "location": "westus",
  "properties": {
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "consumerGroup": "$Default",
    "dataFormat": "MULTIJSON",
    "databaseRouting": "Single",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "ignoreFirstRecord": false,
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "storageAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "tableName": "TestTable"
  }
}

Sample response

{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "kind": "EventGrid",
  "location": "westus",
  "properties": {
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "consumerGroup": "$Default",
    "dataFormat": "MULTIJSON",
    "databaseRouting": "Single",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "ignoreFirstRecord": false,
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "storageAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "tableName": "TestTable"
  }
}
{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "kind": "EventGrid",
  "location": "westus",
  "properties": {
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "consumerGroup": "$Default",
    "dataFormat": "MULTIJSON",
    "databaseRouting": "Single",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "ignoreFirstRecord": false,
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "storageAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "tableName": "TestTable"
  }
}
{
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "kind": "EventGrid",
  "location": "westus",
  "properties": {
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "consumerGroup": "$Default",
    "dataFormat": "MULTIJSON",
    "databaseRouting": "Single",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "ignoreFirstRecord": false,
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "mappingRuleName": "TestMapping",
    "storageAccountResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "tableName": "TestTable"
  }
}

KustoDataConnectionsEventGridWithManagedIdentityCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster/databases/KustoDatabase8/dataConnections/dataConnectionTest?api-version=2025-02-14

{
  "location": "westus",
  "kind": "EventGridWithManagedIdentity",
  "properties": {
    "ignoreFirstRecord": false,
    "storageAccountResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "consumerGroup": "$Default",
    "tableName": "TestTable",
    "mappingRuleName": "TestMapping",
    "dataFormat": "MULTIJSON",
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "databaseRouting": "Single"
  }
}

Sample response

{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventGridWithManagedIdentity",
  "properties": {
    "ignoreFirstRecord": false,
    "storageAccountResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "consumerGroup": "$Default",
    "tableName": "TestTable",
    "mappingRuleName": "TestMapping",
    "dataFormat": "MULTIJSON",
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "databaseRouting": "Single"
  }
}
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventGridWithManagedIdentity",
  "properties": {
    "ignoreFirstRecord": false,
    "storageAccountResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "consumerGroup": "$Default",
    "tableName": "TestTable",
    "mappingRuleName": "TestMapping",
    "dataFormat": "MULTIJSON",
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "databaseRouting": "Single"
  }
}
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/KustoDataConnection9",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventGridWithManagedIdentity",
  "properties": {
    "ignoreFirstRecord": false,
    "storageAccountResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount",
    "eventGridResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Storage/storageAccounts/teststorageaccount/providers/Microsoft.EventGrid/eventSubscriptions/eventSubscriptionTest",
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest2",
    "consumerGroup": "$Default",
    "tableName": "TestTable",
    "mappingRuleName": "TestMapping",
    "dataFormat": "MULTIJSON",
    "blobStorageEventType": "Microsoft.Storage.BlobCreated",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "managedIdentityObjectId": "87654321-1234-1234-1234-123456789123",
    "databaseRouting": "Single"
  }
}

KustoDataConnectionsEventHubWithManagedIdentityCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster/databases/KustoDatabase8/dataConnections/dataConnectionTest?api-version=2025-02-14

{
  "location": "westus",
  "kind": "EventHubWithManagedIdentity",
  "properties": {
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "consumerGroup": "testConsumerGroup1"
  }
}

Sample response

{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventHubWithManagedIdentity",
  "properties": {
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "consumerGroup": "testConsumerGroup1",
    "compression": "None"
  }
}
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventHubWithManagedIdentity",
  "properties": {
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "consumerGroup": "testConsumerGroup1",
    "compression": "None"
  }
}
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster/Databases/KustoDatabase8/DataConnections/dataConnectionTest",
  "name": "kustoCluster/KustoDatabase8/dataConnectionTest",
  "type": "Microsoft.Kusto/Clusters/Databases/DataConnections",
  "location": "westus",
  "kind": "EventHubWithManagedIdentity",
  "properties": {
    "eventHubResourceIdForManagedIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.EventHub/namespaces/eventhubTestns1/eventhubs/eventhubTest1",
    "managedIdentityResourceId": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/managedidentityTest1",
    "consumerGroup": "testConsumerGroup1",
    "compression": "None"
  }
}

Definitions

Name Description
BlobStorageEventType

The name of blob storage event type to process.

Compression

The compression type

CosmosDbDataConnection

Class representing a CosmosDb data connection.

createdByType

The type of identity that created the resource.

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

DataConnectionKind

Kind of the endpoint for the data connection

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

EventGridDataConnection

Class representing an Event Grid data connection.

EventGridDataConnectionWithManagedIdentity

Class representing an Event Grid data connection with mandatory managed identity.

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

EventHubDataConnection

Class representing an event hub data connection.

EventHubDataConnectionWithManagedIdentity

Class representing an event hub data connection with required managed identity.

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

IotHubDataConnection

Class representing an iot hub data connection.

IotHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

ProvisioningState

The provisioned state of the resource.

systemData

Metadata pertaining to creation and last modification of the resource.

BlobStorageEventType

The name of blob storage event type to process.

Value Description
Microsoft.Storage.BlobCreated

Microsoft.Storage.BlobCreated

Microsoft.Storage.BlobRenamed

Microsoft.Storage.BlobRenamed

Compression

The compression type

Value Description
None

None

GZip

GZip

CosmosDbDataConnection

Class representing a CosmosDb data connection.

Name Type Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

CosmosDb

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.cosmosDbAccountResourceId

string

The resource ID of the Cosmos DB account used to create the data connection.

properties.cosmosDbContainer

string

The name of an existing container in the Cosmos DB database.

properties.cosmosDbDatabase

string

The name of an existing database in the Cosmos DB account.

properties.managedIdentityObjectId

string

The object ID of the managed identity resource.

properties.managedIdentityResourceId

string

The resource ID of a managed system or user-assigned identity. The identity is used to authenticate with Cosmos DB.

properties.mappingRuleName

string

The name of an existing mapping rule to use when ingesting the retrieved data.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.retrievalStartDate

string (date-time)

Optional. If defined, the data connection retrieves Cosmos DB documents created or updated after the specified retrieval start date.

properties.tableName

string

The case-sensitive name of the existing target table in your cluster. Retrieved data is ingested into this table.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

DatabaseRouting

Indication for database routing information from the data connection, by default only database routing information is allowed

Value Description
Single

Single

Multi

Multi

DataConnectionKind

Kind of the endpoint for the data connection

Value Description
EventHub

EventHub

EventGrid

EventGrid

IotHub

IotHub

CosmosDb

CosmosDb

EventHubWithManagedIdentity

EventHubWithManagedIdentity

EventGridWithManagedIdentity

EventGridWithManagedIdentity

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

EventGridDataConnection

Class representing an Event Grid data connection.

Name Type Default value Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

EventGrid

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.blobStorageEventType

BlobStorageEventType

The name of blob storage event type to process.

properties.consumerGroup

string

The event hub consumer group.

properties.dataFormat

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Single

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventGridResourceId

string

The resource ID of the event grid that is subscribed to the storage account events.

properties.eventHubResourceId

string

The resource ID where the event grid is configured to send events.

properties.ignoreFirstRecord

boolean

A Boolean value that, if set to true, indicates that ingestion should ignore the first record of every file

properties.managedIdentityObjectId

string

The object ID of managedIdentityResourceId

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub and storage account.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.storageAccountResourceId

string

The resource ID of the storage account where the data resides.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

EventGridDataConnectionWithManagedIdentity

Class representing an Event Grid data connection with mandatory managed identity.

Name Type Default value Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

EventGridWithManagedIdentity

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.blobStorageEventType

BlobStorageEventType

The name of blob storage event type to process.

properties.consumerGroup

string

The event hub consumer group.

properties.dataFormat

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Single

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventGridResourceId

string

The resource ID where the event grid is configured to send events.

properties.eventHubResourceIdForManagedIdentity

string

The resource ID of the event hub that is subscribed to the storage account events.

properties.ignoreFirstRecord

boolean

A Boolean value that, if set to true, indicates that ingestion should ignore the first record of every file

properties.managedIdentityObjectId

string

The object ID of managedIdentityResourceId

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub and storage account.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.storageAccountResourceIdForManagedIdentity

string

The resource ID of the storage account where the data resides.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

EventGridDataFormat

The data format of the message. Optionally the data format can be added to each message.

Value Description
MULTIJSON

MULTIJSON

JSON

JSON

CSV

CSV

TSV

TSV

SCSV

SCSV

SOHSV

SOHSV

PSV

PSV

TXT

TXT

RAW

RAW

SINGLEJSON

SINGLEJSON

AVRO

AVRO

TSVE

TSVE

PARQUET

PARQUET

ORC

ORC

APACHEAVRO

APACHEAVRO

W3CLOGFILE

W3CLOGFILE

AZMONSTREAM

AZMONSTREAM

EventHubDataConnection

Class representing an event hub data connection.

Name Type Default value Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

EventHub

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.compression

Compression

None

The compression type

properties.consumerGroup

string

The event hub consumer group.

properties.dataFormat

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Single

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventHubResourceId

string

The resource ID of the event hub to be used to create a data connection.

properties.eventSystemProperties

string[]

System properties of the event hub

properties.managedIdentityObjectId

string

The object ID of the managedIdentityResourceId

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

EventHubDataConnectionWithManagedIdentity

Class representing an event hub data connection with required managed identity.

Name Type Default value Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

EventHubWithManagedIdentity

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.compression

Compression

None

The compression type

properties.consumerGroup

string

The event hub consumer group.

properties.dataFormat

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Single

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventHubResourceIdForManagedIdentity

string

The resource ID of the event hub to be used to create a data connection.

properties.eventSystemProperties

string[]

System properties of the event hub

properties.managedIdentityObjectId

string

The object ID of the managedIdentityResourceId

properties.managedIdentityResourceId

string

The resource ID of a managed identity (system or user assigned) to be used to authenticate with event hub.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

EventHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

Value Description
MULTIJSON

MULTIJSON

JSON

JSON

CSV

CSV

TSV

TSV

SCSV

SCSV

SOHSV

SOHSV

PSV

PSV

TXT

TXT

RAW

RAW

SINGLEJSON

SINGLEJSON

AVRO

AVRO

TSVE

TSVE

PARQUET

PARQUET

ORC

ORC

APACHEAVRO

APACHEAVRO

W3CLOGFILE

W3CLOGFILE

AZMONSTREAM

AZMONSTREAM

IotHubDataConnection

Class representing an iot hub data connection.

Name Type Default value Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

kind string:

IotHub

Kind of the endpoint for the data connection

location

string

Resource location.

name

string

The name of the resource

properties.consumerGroup

string

The iot hub consumer group.

properties.dataFormat

IotHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

properties.databaseRouting

DatabaseRouting

Single

Indication for database routing information from the data connection, by default only database routing information is allowed

properties.eventSystemProperties

string[]

System properties of the iot hub

properties.iotHubResourceId

string

The resource ID of the Iot hub to be used to create a data connection.

properties.mappingRuleName

string

The mapping rule to be used to ingest the data. Optionally the mapping information can be added to each message.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.retrievalStartDate

string (date-time)

When defined, the data connection retrieves existing Event hub events created since the Retrieval start date. It can only retrieve events retained by the Event hub, based on its retention period.

properties.sharedAccessPolicyName

string

The name of the share access policy

properties.tableName

string

The table where the data should be ingested. Optionally the table information can be added to each message.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

IotHubDataFormat

The data format of the message. Optionally the data format can be added to each message.

Value Description
MULTIJSON

MULTIJSON

JSON

JSON

CSV

CSV

TSV

TSV

SCSV

SCSV

SOHSV

SOHSV

PSV

PSV

TXT

TXT

RAW

RAW

SINGLEJSON

SINGLEJSON

AVRO

AVRO

TSVE

TSVE

PARQUET

PARQUET

ORC

ORC

APACHEAVRO

APACHEAVRO

W3CLOGFILE

W3CLOGFILE

AZMONSTREAM

AZMONSTREAM

ProvisioningState

The provisioned state of the resource.

Value Description
Running

Running

Creating

Creating

Deleting

Deleting

Succeeded

Succeeded

Failed

Failed

Moving

Moving

Canceled

Canceled

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.